﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

using Niwar.Framework.Common;

namespace Niwar.Framework.Helper
{
    /// <summary>
    /// 对SEO友好的汉字标题转拼音
    /// </summary>
    public class PingyingHelper
    {
        private static string getEnglish(string Str)
        {
            Str = Str.Replace("中国", " china ");
            Str = Str.Replace("策划", " plan ");
            Str = Str.Replace("免费", " free ");
            Str = Str.Replace("介绍", " intro ");
            Str = Str.Replace("技巧", " skill ");
            Str = Str.Replace("生活", " life ");
            Str = Str.Replace("活动", " activity ");
            Str = Str.Replace("工具", " tool ");
            Str = Str.Replace("联盟", " union ");
            Str = Str.Replace("注册", " register ");
            Str = Str.Replace("经验", " experience ");
            Str = Str.Replace("翻译", " translate ");
            Str = Str.Replace("项目", " item ");
            Str = Str.Replace("网站", " web-site ");
            Str = Str.Replace("英语", " english ");
            Str = Str.Replace("英文", " english ");
            Str = Str.Replace("雅虎", " yahoo ");
            Str = Str.Replace("新浪", " sina ");
            Str = Str.Replace("支付宝", " alipay ");
            Str = Str.Replace("交易", " trade ");
            Str = Str.Replace("网店", " b2c ");
            Str = Str.Replace("升级", " update ");
            Str = Str.Replace("杂志", " magazine ");
            Str = Str.Replace("空间", " space ");
            Str = Str.Replace("爱情", " love ");
            Str = Str.Replace("朋友", " friend ");
            Str = Str.Replace("友情", " friend ");
            Str = Str.Replace("链接", " like ");
            Str = Str.Replace("标签", " label ");
            Str = Str.Replace("运行", " running ");
            Str = Str.Replace("管理", " manager ");
            Str = Str.Replace("管理", " manage ");
            Str = Str.Replace("页面", " page ");
            Str = Str.Replace("模板", " template ");
            Str = Str.Replace("游戏", " game ");
            Str = Str.Replace("论坛", " forum ");
            Str = Str.Replace("新闻", " news ");
            Str = Str.Replace("音乐", " music ");
            Str = Str.Replace("帮助", " help ");
            Str = Str.Replace("优化", " optimize ");
            Str = Str.Replace("软件", " soft ");
            Str = Str.Replace("教程", " tech ");
            Str = Str.Replace("下载", " download ");
            Str = Str.Replace("搜索", " search ");
            Str = Str.Replace("引擎", " engine ");
            Str = Str.Replace("蜘蛛", " spider ");
            Str = Str.Replace("日志", " log ");
            Str = Str.Replace("博客", " blog ");
            Str = Str.Replace("百度", " baidu ");
            Str = Str.Replace("谷歌", " google ");
            Str = Str.Replace("邮箱", " mailbox ");
            Str = Str.Replace("邮件", " mail ");
            Str = Str.Replace("域名", " domain ");
            Str = Str.Replace("测试", " test");
            Str = Str.Replace("演示", " demo ");
            Str = Str.Replace("音乐", " music ");
            Str = Str.Replace("笑话", " joke ");
            Str = Str.Replace("产品", " product ");
            Str = Str.Replace("留言", " message ");
            Str = Str.Replace("反馈", " freedback ");
            Str = Str.Replace("评论", " comment ");
            Str = Str.Replace("推荐", " commend ");
            Str = Str.Replace("共享", " share ");
            Str = Str.Replace("资源", " resource ");
            Str = Str.Replace("插件", " plugins ");
            Str = Str.Replace("本本", " notebook ");
            Str = Str.Replace("电脑", " computer ");
            Str = Str.Replace("系统", " system ");
            Str = Str.Replace("学校", " school ");
            Str = Str.Replace("无忧", " 5u ");
            Str = Str.Replace("工作", " job ");
            Str = Str.Replace("信息", " info ");
            Str = Str.Replace("娱乐", " ent ");
            Str = Str.Replace("汽车", " car ");
            Str = Str.Replace("手机", " mobile ");
            Str = Str.Replace("网络", " network ");
            Str = Str.Replace("老板", " boss ");
            Str = Str.Replace("狗", " dog ");
            Str = Str.Replace("电视", " tv ");
            Str = Str.Replace("电影", " movie ");
            Str = Str.Replace("其他", " other ");
            Str = Str.Replace("出租车", " taix ");
            Str = Str.Replace("司机", " driver ");
            Str = Str.Replace("项目", " project ");
            return Str;
        }

        /// <summary>
        /// 转换成拼音形式的url
        /// </summary>
        /// <param name="chinese"></param>
        /// <returns></returns>
        public static string pinyin(string chinese)
        {
            chinese = chinese.Replace("/", "");
            chinese = chinese.Replace("\\", "");
            chinese = chinese.Replace("*", "");
            chinese = chinese.Replace("]", "");
            chinese = chinese.Replace("[", "");
            chinese = chinese.Replace("}", "");
            chinese = chinese.Replace("{", "");
            chinese = chinese.Replace("'", "");
            chinese = getEnglish(chinese); //在这里使用getEnglish先将特殊词语转换

            string pinyinstr = "", istr;
            bool iIsCn, IsCn = true;

            //打开拼音库
            DataTable dt = null;
            try
            {
                dt = new DataTable(); //XlsHelper.GetDatasetFromExcel(Utils.GetMapPath("~/App_Data/PinYin.xls")).Tables[0];

                for (int i = 0; i < chinese.Length; i++)
                {
                    iIsCn = IsCn;
                    istr = chinese.Substring(i, 1);
                    int x = Ascii(istr);
                    if ((x >= 65 && x <= 90) || (x >= 97 && x <= 122) || (x >= 48 && x <= 57) || istr == " ")
                    {
                        IsCn = false; // 这些是英文,数字(保留字符),不改动
                        if (istr == " ") istr = "-";
                    }
                    else
                    {
                        DataRow[] dr = dt.Select("[content] like '%" + istr + "%'");
                        if (dr.Length > 0)
                        {
                            istr = dr[0]["pinyin"].ToString().ToLower() + "-";
                            IsCn = true;
                        }
                        else
                        {
                            IsCn = false;
                            if (istr == " ")
                                istr = "-";
                            else
                                istr = ""; //将空格转换成-,如果是其他字符则清除
                        }
                    }
                    if (iIsCn == IsCn)
                        pinyinstr = pinyinstr + istr;
                    else
                        pinyinstr = pinyinstr + "-" + istr;
                    pinyinstr = pinyinstr.Replace("--", "-");
                    pinyinstr = pinyinstr.Replace("__", "_");
                }

                if (pinyinstr.Substring(0, 1) == "-" || pinyinstr.Substring(0, 1) == "_") pinyinstr = pinyinstr.Remove(0, 1);
                if (pinyinstr.Substring(pinyinstr.Length - 1, 1) == "-" || pinyinstr.Substring(pinyinstr.Length - 1, 1) == "_") pinyinstr = pinyinstr.Remove(pinyinstr.Length - 1, 1);

                return pinyinstr.Trim().ToLower();
            }
            catch
            {
                return null;
            }
        }

        /// <summary>
        /// 是否为双字节字符。
        /// </summary>
        private static bool istwobyteschar(string chr)
        {
            string str = chr.ToString();
            // 使用中文支持编码
            Encoding ecode = Encoding.GetEncoding("gb18030");
            if (ecode.GetByteCount(str) == 2)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 得到字符的ascii码
        /// </summary>
        private static int Ascii(string chr)
        {
            Encoding ecode = Encoding.GetEncoding("gb18030");
            byte[] codebytes = ecode.GetBytes(chr.ToString());
            if (istwobyteschar(chr))
            {
                // 双字节码为高位乘256，再加低位
                // 该为无符号码，再减65536
                return (int)codebytes[0] * 256 + (int)codebytes[1] - 65536;
            }
            else
            {
                return (int)codebytes[0];
            }
        }

    }
}
