﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Nimmo.Infrastructure.Relators
{
    public class RoleRelator
    {
        public Role current;
        public Role Map(Role role, RoleMenu roleMenu)
        {
            // Terminating call.  Since we can return null from this function
            // we need to be ready for PetaPoco to callback later with null
            // parameters
            if (role == null)
                return current;

            // Is this the same article as the current one we're processing
            if (current != null && current.Id == role.Id)
            {
                // Yes, just add this tag to the current article's collection of tags
                current.Menus.Add(roleMenu);

                // Return null to indicate we're not done with this article yet
                return null;
            }

            // This is a different author to the current one, or this is the 
            // first time through and we don't have an author yet

            // Save the current author
            var prev = current;

            // Setup the new current author
            current = role;

            if (roleMenu.Id != int.MinValue) current.Menus.Add(roleMenu);
            //current.Tags = new List<Tag>();
            //current.posts.Add(p);

            // Return the now populated previous author (or null if first time through)
            return prev;
        }
    }
}
