﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Nimmo.Infrastructure.Relators
{
    public class UserRelator
    {
        public UserInfo current;
        public UserInfo Map(UserInfo user,Team team, Role role)
        {
            // Terminating call.  Since we can return null from this function
            // we need to be ready for PetaPoco to callback later with null
            // parameters
            if (user == null)
                return current;

            // Is this the same article as the current one we're processing
            if (current != null && current.Id == user.Id)
            {
                if (current.Team == null) current.Team = team;

                // Yes, just add this tag to the current article's collection of tags
                current.Roles.Add(role);

                // Return null to indicate we're not done with this article yet
                return null;
            }

            // This is a different author to the current one, or this is the 
            // first time through and we don't have an author yet

            // Save the current author
            var prev = current;

            // Setup the new current author
            current = user;
            current.Team = team;
            if (role.Id > 0) current.Roles.Add(role);
            //current.Tags = new List<Tag>();
            //current.posts.Add(p);

            // Return the now populated previous author (or null if first time through)
            return prev;
        }
    }
}
