﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Nimmo.Framework.Common;
using Nimmo.Framework.Data.PetaPoco;

namespace Nimmo.Infrastructure.Repositories
{
    public class RoleMenuRepository : SingleRepository<RoleMenu>
    {
        /// <summary>
        /// 获取指定用户拥有的菜单信息
        /// </summary>
        /// <param name="UserID"></param>
        /// <returns></returns>
        public IList<RoleMenu> GetRoleMenusByUserID(int UserID)
        {
            Sql sql = Sql.Builder.Select("RoleMenus.*").From("RoleMenus")
                            .LeftJoin("RolesToMenus").On("RolesToMenus.RoleMenuId=RoleMenus.RoleMenuId")
                            .LeftJoin("Roles").On("Roles.RoleId=RolesToMenus.RoleId")
                            .LeftJoin("RolesToUsers").On("RolesToUsers.RoleId=Roles.RoleId")
                            .LeftJoin("Users").On("Users.UserId=RolesToUsers.UserId")
                            .Where("Users.UserId=@0", UserID);

            return this.Query(sql).ToList();
        }

        /// <summary>
        /// 获取所有菜单
        /// </summary>
        /// <returns></returns>
        public IList<RoleMenu> GetAll()
        {
            return this.Query(Sql.Builder.Where("1=1")).ToList();
        }

        /// <summary>
        /// 删除
        /// </summary>
        /// <param name="ID"></param>
        public void Delete(int RoleMenuID)
        {
            using (var trans = this.db.GetTransaction())
            {
                Sql sql = Sql.Builder.Append("delete from RolesToMenus where [RoleMenuId]=@0", RoleMenuID);
                //删除菜单的关联
                this.Execute(sql);
                //删除角色
                this.DeleteById(RoleMenuID);

                trans.Complete();
            }
        }
    }
}
