﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Nimmo.Framework.Common;
using Nimmo.Framework.Data.PetaPoco;

namespace Nimmo.Infrastructure.Repositories
{
    public class TeamRepository : SingleRepository<Team>
    {
        /// <summary>
        /// 获取所有团队数据
        /// </summary>
        /// <returns></returns>
        public IList<Team> GetAll()
        {
            return this.Query(Sql.Builder.Where("1=1")).ToList();
        }

        /// <summary>
        /// 根据ID获取团队信息
        /// </summary>
        /// <param name="TeamID"></param>
        /// <returns></returns>
        public Team GetById(int TeamID)
        {
            Sql sql = Sql.Builder.Select("a.*,b.TeamName ParentName")
                .From("Teams a")
                .LeftJoin("Teams b").On("a.ParentID=b.TeamID")
                .Where("a.TeamID=@0",TeamID);

            return this.Single(sql);
        }

        /// <summary>
        /// 删除团队
        /// </summary>
        /// <param name="TeamID"></param>
        public void Delete(int TeamID)
        {
            using (var trans = this.db.GetTransaction())
            {
                Sql sql = Sql.Builder.Append("update Users set TeamID=0 Where TeamID=@0", TeamID);
                //删除关联此团队的用户
                this.Execute(sql);
                //删除团队
                this.DeleteById(TeamID);

                trans.Complete();
            }
        }
    }
}
