﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Nimmo.Framework.Common;
using Nimmo.Framework.Data.PetaPoco;
using Nimmo.Framework.ViewModel;

namespace Nimmo.Infrastructure.Repositories
{
    public class UserPortalRepository : SingleRepository<UserPortal>
    {
        /// <summary>
        /// 获取指定用户的所有组件状态
        /// </summary>
        /// <param name="UserID"></param>
        /// <returns></returns>
        public List<UserPortal> GetAll(int UserID)
        {
            var data = this.Query(Sql.Builder.Where("UserID=@0 and PageTag<>'Home'", UserID)).ToList();
            
            return data;
        }

        /// <summary>
        /// 获取指定用户指定页面的布局信息
        /// </summary>
        /// <param name="UserID"></param>
        /// <param name="PageCode"></param>
        /// <returns></returns>
        public string GetPortal(int UserID, string PageCode)
        {
            UserPortal userportal = this.Single(Sql.Builder.Where("PageTag=@0 and UserId=@1", PageCode,UserID));
            if (userportal != null)
                return userportal.JosnPortal;

            return "";
        }

        /// <summary>
        /// 保存指定用户指定页面的布局信息
        /// </summary>
        /// <param name="UserID"></param>
        /// <param name="PageCode"></param>
        /// <param name="PortalJson"></param>
        public void SavePortal(int UserID, string PageCode, string PortalJson)
        {
            UserPortal entity = this.Single(Sql.Builder.Where("PageTag=@0 and UserId=@1", PageCode, UserID));

            if (entity == null) entity = new UserPortal();
            entity.PageTag = PageCode;
            entity.JosnPortal = PortalJson;
            entity.UserId = UserID;

            this.SaveOrUpdate(entity);
        }
    }
}
