﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;

using Nimmo.Framework.Common;
using Nimmo.Infrastructure.Repositories;

namespace Nimmo.Infrastructure.ViewModel
{
    public class LoginModel
    {
        [Required]
        public string LoginName { get; set; }
        [Required]
        public string LoginPassword { get; set; }

        private readonly UserInfoRepository _UserInfoRepository = new UserInfoRepository();
        private readonly LogRepository _LoginLogRepository = new LogRepository();

        /// <summary>
        /// 根据登录名判断用户是否存在
        /// </summary>
        /// <returns></returns>
        public bool ExistsByLoginName()
        {
            return _UserInfoRepository.ExistsByLoginName(this.LoginName);
        }
        /// <summary>
        /// 根据登录名和密码取得用户信息，如找不到相应用户则返回null
        /// </summary>
        /// <returns></returns>
        public UserInfo GetByLoginNameAndPwd()
        {
            return _UserInfoRepository.GetByLoginNameAndPwd(this.LoginName, this.LoginPassword);
        }
    }
}
