﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Niwar.Framework;
using Niwar.Framework.Data;

namespace Niwar.MVC.Filter
{
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Method, AllowMultiple = false)]
    public class ExceptionFilterAttribute : ActionFilterAttribute
    {
        public override void OnActionExecuted(ActionExecutedContext filterContext)
        {
            if (filterContext.Exception != null)
            {
                Exception ex = filterContext.Exception; //获取异常源

                if (ex.GetType() == typeof(RepositoryException) || ex.GetType() == typeof(NiwarException))
                {
                    var excResult = new ContentResult();
                    excResult.Content = "{\"success\":false,\"msg\":\"" + filterContext.Exception.GetBaseException().Message + "\",\"id\":null}";
                    filterContext.Result = excResult;

                    filterContext.ExceptionHandled = true;
                }
            }
        }
    }
}
