﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web;
using System.Web.Security;

namespace Niwar.MVC
{
    public class NiwarApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {
            //判断有效的身份验证信息
            if (HttpContext.Current.User != null && 
                HttpContext.Current.User.Identity.IsAuthenticated && 
                HttpContext.Current.User.Identity is FormsIdentity)
            {
                //获得进行了Forms身份验证的用户标识  
                FormsIdentity UserIdent = (FormsIdentity)(HttpContext.Current.User.Identity);
                //从身份验证票中获得用户数据  
                string UserData = UserIdent.Ticket.UserData;
                //分割用户数据得到用户角色数组  
                string[] rolues = UserData.Split(',');
                //从用户标识和角色组初始化GenericPrincipal类  
                HttpContext.Current.User = new System.Security.Principal.GenericPrincipal(UserIdent, rolues);
            }
        } 
    }
}
